/*
 * AN00219_headset_output.h
 *
 *  Created on: 18. okt. 2021
 *      Author: oyvindteig
 *      Inherited from my version of app_lores_DAS_fixed.xc in AN00219_app_lores_DAS_fixed
 */


#ifndef AN00219_MIC_OUPUT_H_
    #define MY_LIB_MIC_ARRAY_BOARD_SUPPORT_H_

    #define I2C_ADDRESS_OF_DAC 0x4A // CS43L21, see page 5 of mic_array board manual
    //
    typedef enum i2c_reg_addr_dac_headphones_cs43l21_e {
        CS41L21_DAC_REG_01_CHIP_ID_AND_REVISION                      = 0x01, // USED
        CS41L21_DAC_REG_02_POWER_CONTROL_1                           = 0x02, // USED
        CS41L21_DAC_REG_03_SPEED_CONTROL                             = 0x03, // USED
        CS41L21_DAC_REG_04_INTERFACE_CONTROL                         = 0x04,
        CS41L21_DAC_REG_08_DAC_OUTPUT_CONTROL                        = 0x08,
        CS41L21_DAC_REG_09_DAC_CONTROL                               = 0x09,
        CS41L21_DAC_REG_10_MIXER_VOLUME_CONTROL_PCMA                 = 0x10, // USED
        CS41L21_DAC_REG_11_MIXER_VOLUME_CONTROL_PCMB                 = 0x11,
        CS41L21_DAC_REG_12_BEEP_FREQUENCY_AND_TIMING_CONFIGURATION   = 0x12,
        CS41L21_DAC_REG_13_BEEP_OFF_TIME_AND_VOLUME                  = 0x13,
        CS41L21_DAC_REG_14_BEEP_CONFIGURATION_AND_TONE_CONFIGURATION = 0x14,
        CS41L21_DAC_REG_15_TONE_CONTROL                              = 0x15,
        CS41L21_DAC_REG_16_VOLUME_CONTROL_AOUTA                      = 0x16,
        CS41L21_DAC_REG_17_VOLUME_CONTROL_AOUTB                      = 0x17,
        CS41L21_DAC_REG_18_PCM_CHANNEL_MIXER                         = 0x18,
        CS41L21_DAC_REG_19_LIMITER_THRESHOLD_SZC_DISABLE             = 0x19,
        CS41L21_DAC_REG_1A_LIMITER_RELEASE_RATE_REGISTER             = 0x1A,
        CS41L21_DAC_REG_1B_LIMITER_ATTACK_RATE_REGISTER              = 0x1B,
        CS41L21_DAC_REG_20_STATUS                                    = 0x20,
        CS41L21_DAC_REG_21_CHARGE_PUMP_FREQUENCY                     = 0x21
    } i2c_reg_addr_dac_headphones_cs43l21_e;

    #define I2C_ADDRESS_OF_PLL 0x4E // CS2100-CP, see page 5 of mic_array board manual
    //
    typedef enum i2c_reg_addr_pll_cs2100cp_e {
        CS2100CP_PLL_REG_01_DEVICE_ID_AND_REVISION   = 0x01,
        CS2100CP_PLL_REG_02_DEVICE_CONTROL           = 0x02,
        CS2100CP_PLL_REG_03_DEVICE_CONFIGURATION_1   = 0x03,
        CS2100CP_PLL_REG_05_GLOBAL_CONFIGURATION     = 0x05,
        CS2100CP_PLL_REG_06_RATIO                    = 0x06,
        CS2100CP_PLL_REG_07_RATIO                    = 0x07,
        CS2100CP_PLL_REG_08_RATIO                    = 0x08,
        CS2100CP_PLL_REG_09_RATIO                    = 0x09,
        CS2100CP_PLL_REG_16_FUNCTION_CONFIGURATION_1 = 0x16,
        CS2100CP_PLL_REG_17_FUNCTION_CONFIGURATION_2 = 0x17,
        CS2100CP_PLL_REG_1E_FUNCTION_CONFIGURATION_3 = 0x1E
    } i2c_reg_addr_pll_cs2100cp_e;

    [[distributable]]
    void i2s_handler (
            server  i2s_callback_if i2s, // From i2s_master0
            client  i2c_master_if   i2c,
            port    p_rst_shared,
            chanend c_audio);
#else
    #error NESTED .h FILE
#endif
